#!/bin/sh



CAM_ENTITY_NUMBER=vm050@4a
CAM_BW_FMT=Y8
IPU0_CSI0_DEVICE=$(media-ctl -e "ipu0-csi0-video")
IPU1_CSI1_DEVICE=$(media-ctl -e "ipu1-csi1-video")
CAM_DEVICE=$(media-ctl -e "vm050@4a")
CAM_I2C_BUS=$(find /sys/bus/i2c/drivers/phytec-vm050/ -name "?-00*" | cut -d / -f 7 | cut -c1-1)
CAMERA_TYP=$(i2cget -y -f $CAM_I2C_BUS 0x4a 0x00 w | cut -c 4)

if [ "$CAMERA_TYP" = "1" ]; then
	CAMERA="VM-050"
	GRAB_RES="32x32"
elif [ "$CAMERA_TYP" = "2" ]; then
	CAMERA="VM-051"
	GRAB_RES="80x64"
else
	echo " no camera driver loaded"
	echo " please check camera device tree" 
	echo ""
	return 1
fi

echo ""
echo " found camera = $CAMERA"
echo " camera entity name = $CAM_ENTITY_NUMBER"
echo " camera subdevice name = $CAM_DEVICE"
echo " ipu0_CSI0 devive name = $IPU0_CSI0_DEVICE"
echo " ipu1_CSI1 devive name = $IPU1_CSI1_DEVICE"
echo ""

echo "pixel depth"
echo "================="
echo "1 = 8-Bit"
echo "2 = 10-Bit"
echo "3 = 12-Bit"
#echo "4 = 16-Bit (Format: CAM_BW_FMT = Y16_2x8)"
read PIX_DEPTH
echo "Your select = $PIX_DEPTH"
case $PIX_DEPTH in
  "1") CAM_BW_FMT="Y8";;
  "2") CAM_BW_FMT="Y10";;
  "3") CAM_BW_FMT="Y12";;
  *) CAM_BW_FMT="Y8";;
esac

echo ""
echo "configure IPU/VPU with media_control"
echo "===================================="

media-ctl -r
media-ctl -V "\"$CAM_ENTITY_NUMBER\":0[fmt:$CAM_BW_FMT/$GRAB_RES (0,0)/$GRAB_RES]"
media-ctl -V '"ipu0-csi0-sd":0[fmt:'$CAM_BW_FMT'/'$GRAB_RES']'
media-ctl -V '"ipu0-csi0-sd":1[fmt:'$CAM_BW_FMT'/'$GRAB_RES']'
#media-ctl -l '2:0 -> 1:0[1], 1:1 -> 2:0[1]'
#           Camera -> IPU0-CSI0-sd -> IPU0-CSI0-video (/dev/videoX)

# Additional Settings
COL_FMT=$CAM_BW_FMT
X_RES=${GRAB_RES%%x*}
Y_RES=${GRAB_RES##*x}
NUMBER_OF_PIC=2
#REG_SET_FILE=/usr/share/phytec-gstreamer-examples/${REG_SET_FILE##*/}


echo "starting save_raw_image with format $COL_FMT"
echo "read $X_RES x $Y_RES and write to RAW-file"
echo "============================================="

save_raw_image -D $IPU0_CSI0_DEVICE -sd_cam $CAM_DEVICE -f $COL_FMT -res_x $X_RES -res_y $Y_RES -d $NUMBER_OF_PIC -n $CAMERA"_PixDepth_"$CAM_BW_FMT"_"
